---
title: Animation.updatePlaybackRate()
slug: Web/API/Animation/updatePlaybackRate
tags:
  - API
  - Animation
  - Experimental
  - Interface
  - Method
  - Reference
  - Web Animations
  - playbackRate
  - updatePlaybackRate
  - waapi
  - web animations api
---
<p>{{APIRef("Web Animations")}}{{SeeCompatTable}}</p>

<div>
<p><span class="seoSummary">The <strong><code>updatePlaybackRate()</code> </strong>method of the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a>'s {{domxref("Animation")}} Interface sets the speed of an animation after first synchronizing its playback position.</span></p>

<p>In some cases, an animation may run on a separate thread or process and will continue updating even while long-running JavaScript delays the main thread. In such a case, setting the {{domxref("Animation.playbackRate", "playbackRate")}} on the animation directly may cause the animation's playback position to jump since its playback position on the main thread may have drifted from the playback position where it is currently running.</p>

<p><code>updatePlaybackRate()</code> is an asynchronous method that sets the speed of an animation after synchronizing with its current playback position, ensuring that the resulting change in speed does not produce a sharp jump. After calling <code>updatePlaybackRate()</code> the animation's {{domxref("Animation.playbackRate", "playbackRate")}} is <em>not</em> immediately updated. It will be updated once the animation's {{domxref("Animation.ready", "ready")}} promise is resolved.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>Animation</em>.updatePlaybackRate(2); </pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>playbackRate</dt>
 <dd><span style="line-height: 1.5;">The new speed to set</span><span style="line-height: 1.5;">. This may be a positive number (to speed up or slow down the animation), a negative number (to make it play backwards), or zero (to effectively pause the animation).</span></dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>A speed selector component would benefit from smooth updating of <code>updatePlaybackRate()</code>, as demonstrated below:</p>

<pre class="brush: js">speedSelector.addEventListener('input', evt =&gt; {
  cartoon.updatePlaybackRate(parseFloat(evt.target.value));
  cartoon.ready.then(() =&gt; {
    console.log(`Playback rate set to ${cartoon.playbackRate}`);
  });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#dom-animation-updateplaybackrate', 'updatePlaybackRate()')}}</td>
   <td>{{Spec2("Web Animations")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Animation.updatePlaybackRate")}}</p>
</div>

<h2 id="See_also" style="line-height: 30px; font-size: 2.14285714285714rem;">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Animation.playbackRate")}} — read back the current playback rate or set it in a synchronous manner.</li>
 <li>{{domxref("Animation.reverse()")}} — invert the playback rate and restart playback if necessary.</li>
 <li>{{domxref("Animation")}} — contains other methods and properties you can use to control web page animation.</li>
</ul>
